"""Add fixes to label table for disconect it from blocks and address table.

Revision ID: 58e1cafc9722
Revises: d6ed4b1b43d5
Create Date: 2021-09-28 18:44:34.448871

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "58e1cafc9722"
down_revision = "d6ed4b1b43d5"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "ethereum_labels", sa.Column("block_number", sa.BigInteger(), nullable=True)
    )
    op.add_column(
        "ethereum_labels", sa.Column("address", sa.VARCHAR(length=256), nullable=True)
    )
    op.execute(
        "UPDATE ethereum_labels as lables  SET address=(select address from ethereum_addresses where id=lables.address_id)"
    )
    op.drop_index("ix_ethereum_labels_address_id", table_name="ethereum_labels")
    op.create_index(
        op.f("ix_ethereum_labels_address"), "ethereum_labels", ["address"], unique=False
    )
    op.create_index(
        op.f("ix_ethereum_labels_block_number"),
        "ethereum_labels",
        ["block_number"],
        unique=False,
    )
    op.create_index(
        op.f("ix_ethereum_labels_label"), "ethereum_labels", ["label"], unique=False
    )
    op.drop_constraint(
        "fk_ethereum_labels_address_id_ethereum_addresses",
        "ethereum_labels",
        type_="foreignkey",
    )

    op.drop_column("ethereum_labels", "address_id")
    op.create_unique_constraint(
        op.f("uq_opensea_crawler_state_id"), "opensea_crawler_state", ["id"]
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(
        op.f("uq_opensea_crawler_state_id"), "opensea_crawler_state", type_="unique"
    )
    op.add_column(
        "ethereum_labels",
        sa.Column("address_id", sa.INTEGER(), autoincrement=False, nullable=True),
    )
    op.execute(
        "UPDATE ethereum_labels as lables  SET address_id=(select address_id from ethereum_addresses where address=lables.address)"
    )
    op.create_foreign_key(
        "fk_ethereum_labels_address_id_ethereum_addresses",
        "ethereum_labels",
        "ethereum_addresses",
        ["address_id"],
        ["id"],
        ondelete="CASCADE",
    )
    op.drop_index(op.f("ix_ethereum_labels_label"), table_name="ethereum_labels")
    op.drop_index(op.f("ix_ethereum_labels_block_number"), table_name="ethereum_labels")
    op.drop_index(op.f("ix_ethereum_labels_address"), table_name="ethereum_labels")
    op.create_index(
        "ix_ethereum_labels_address_id", "ethereum_labels", ["address_id"], unique=False
    )
    op.drop_column("ethereum_labels", "address")
    op.drop_column("ethereum_labels", "block_number")
    # ### end Alembic commands ###
